# using Revise
using SoleModels
using SoleLogics
using Test
using Random

function run_tests(list)
    println("\n" * ("#"^50))
    for test in list
        println("TEST: $test")
        include(test)
    end
end

println("Julia version: ", VERSION)

test_suites = [
    ("Logisets", [ "logisets/logisets.jl", ]),
    ("Memosets", [ "logisets/memosets.jl", ]),
    ("Cube to Logiset", [ "logisets/cube2logiset.jl", ]),
    ("DataFrame to Logiset", [ "logisets/dataframe2logiset.jl", ]),
    ("MultiLogisets", [ "logisets/multilogisets.jl", ]),
    ("MLJ", [ "logisets/MLJ.jl", ]),
    ("Models", ["base.jl", ]),
    ("Miscellaneous", ["misc.jl", "minify.jl"]),
    ("Parse", ["parse.jl", ]),
    ("Pluto Demo", ["$(dirname(dirname(pathof(SoleModels))))/pluto-demo.jl", ]),
]

@testset "SoleModels.jl" begin
    for ts in eachindex(test_suites)
        name = test_suites[ts][1]
        list = test_suites[ts][2]
        let
            @testset "$name" begin
                run_tests(list)
            end
        end
    end
    println()
end
